﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: False
#End Region

Sub Process_Globals
	Dim xui As XUI
	Dim KVS As KeyValueStore
End Sub

Sub Globals
	Private Drawer As B4XDrawer
	Private CLVL As CustomListView
	Private CLVM As CustomListView
	Private imgProfile As ImageView	
	Private lblProfileName As Label
	Private lblMenuIcon As Label
	Private lblMenuText As Label
	Private pnlStatus As Panel
	Private lblName As Label
	Private btnMenu As Label
	Private pnlBlur As Panel	
	Private lblViewUserName As Label
	Private lblViewUserLocation As Label
	Private txtViewUserLocation As EditText
	Private lblViewUserStatus As Label		
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Drawer.Initialize(Me, "Drawer", Activity, 300dip)
	Drawer.LeftPanel.LoadLayout("LeftMenu")
	Drawer.CenterPanel.LoadLayout("Home")
	If FirstTime Then
		' Auto login if API key exist
		xui.SetDataFolder("KVS")
		KVS.Initialize(xui.DefaultFolder, "app.dat")
	End If
End Sub

Sub Activity_Resume
	Wait For (KVS.GetMapAsync(Array("ApiKey", "Token"))) Complete (M As Map)
	If M.IsInitialized Then
		If M.ContainsKey("Token") Then
			Starter.gUserToken = M.Get("Token")
		End If
		If M.ContainsKey("ApiKey") Then
			Starter.gUserAPIKey = M.Get("ApiKey")
		End If			
	End If
	If Starter.gLogin = 0 Then
		If Starter.gUserAPIKey <> "" Then GetToken
		If Starter.gUserToken <> "" Then
			Starter.gLogin = 1
		End If
	End If
	If Starter.gLogin > 0 Then
		GetProfile
		GetUserList
	Else
		LoadSlideMenu
		Drawer.LeftOpen = True
	End If	
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean
	If KeyCode = KeyCodes.KEYCODE_BACK And Drawer.LeftOpen Then
		Drawer.LeftOpen = False
		Return True
	End If
	Return False
End Sub

Sub btnMenu_Click
	Drawer.LeftOpen = Not(Drawer.LeftOpen)
End Sub

Sub CLVL_ItemClick (Index As Int, Value As Object)
	Drawer.LeftOpen = False
	Select Case Value
		Case "Log in"
			AppUser.strMode = "Login"
			StartActivity(AppUser)
		Case "Register"
			AppUser.strMode = "Register"
			StartActivity(AppUser)
		Case "Change Password"
			AppPassword.strMode = "Change"
			StartActivity(AppPassword)
		Case "About Me"
			AppUser.strMode = "About"
			StartActivity(AppUser)
		Case "Log out"
			Starter.gLogin = 0
			Starter.gUserAPIKey = ""
			Starter.gUserToken = ""
			' Delete Token
			KVS.DeleteAll
			Sleep(0)
			StartActivity(Main)
			Activity.Finish
	End Select
End Sub

Sub LoadSlideMenu
	CLVL.Clear
	If Starter.gLogin = 0 Then
		CLVL.Add(CreateMenu(Chr(0xF090), "Log in", CLVL.AsView.Width), "Log in")
		CLVL.Add(CreateMenu(Chr(0xF234), "Register", CLVL.AsView.Width), "Register")
	Else
		lblProfileName.Text = Starter.gUserName
		CLVL.Add(CreateMenu(Chr(0xF05A), "About Me", CLVL.AsView.Width), "About Me")
		CLVL.Add(CreateMenu(Chr(0xF013), "Change Password", CLVL.AsView.Width), "Change Password")
		CLVL.Add(CreateMenu(Chr(0xF08B), "Log out", CLVL.AsView.Width), "Log out")
	End If
	CLVL.AnimationDuration = 0	
	' Reference: https://www.b4x.com/android/forum/threads/b4x-xui-create-a-round-image.85102/
	Dim xIV As B4XView = imgProfile
	Dim img As B4XBitmap = xui.LoadBitmapResize(File.DirAssets, "default.png", imgProfile.Width, imgProfile.Height, False)
	xIV.SetBitmap(CreateRoundBitmap(img, xIV.Width))
End Sub

Sub GetToken
	Dim parser As JSONParser
	Dim job As HttpJob
	Dim List1 As List
	Dim Map1 As Map
	Dim strError As String
	Dim strData As String
	Dim jsn As String
	Try
		LogColor("[AppHome] GetToken", Colors.Blue)
		ProgressDialogShow("Connecting to server...")
		job.Initialize("", Me)
		job.Download(Starter.strURL & "user/connect")
		Wait For (job) JobDone(job As HttpJob)
		ProgressDialogHide
		If job.Success Then
			strData = job.GetString
			job.Release
			parser.Initialize(strData)
			If Routine.isArray(strData) Then
				List1 = parser.NextArray
				Map1 = List1.Get(0)
				If 1 = Map1.Get("Connected") Then
					If Starter.gUserToken = "" Then
						ProgressDialogShow("Refreshing User Token...")
						Dim Map2 As Map
						Map2.Initialize
						LogColor("API Key=" & Starter.gUserAPIKey, Colors.Red)
						Map2.Put("key", Starter.gUserAPIKey)
						jsn = Routine.Map2Json(Map2)
						job.Initialize("", Me)
						job.PostString(Starter.strURL & "user/gettoken", jsn)
						Wait For (job) JobDone(job As HttpJob)
						ProgressDialogHide
						If job.Success Then
							strData = job.GetString
							job.Release
							Log(strData)
							parser.Initialize(strData)
							If Routine.isArray(strData) Then
								List1 = parser.NextArray
								Map1 = List1.Get(0)
								If -1 = Map1.Get("result") Then
									If Map1.Get("message") = "Error-No-Result" Then
										ToastMessageShow("Error: Invalid API key", False)
									Else If Map1.Get("message") = "Error-No-Value" Then
										ToastMessageShow("Error: Invalid Parameters", False)
									Else
										ToastMessageShow("Error: Uncaught error" & CRLF & Map1.Get("message"), False)
									End If
									Return
								End If
								If Map1.Get("message") = "success" Then
									Starter.gUserToken = Map1.Get("user_token")
								End If
								If Starter.gUserToken = "" Then
									Log("Invalid User Token")
									ToastMessageShow("Error: Invalid User Token. Please contact the developer.", False)
									Return
								End If
								' Write to internal storage
								Dim User As Map = CreateMap("Token": Starter.gUserToken)
								Wait For (KVS.PutMapAsync(User)) Complete (Success As Boolean)
								Log(Success)
							Else
								job.Release
								strData = parser.NextValue
								Log(strData)
								ToastMessageShow("Error: Uncaught error" & CRLF & strData, False)
							End If
						Else
							strError = job.ErrorMessage
							job.Release
							Log(strError)
							Routine.ShowConnectionError(strError)
						End If
					End If
				End If
			Else
				job.Release
				strData = parser.NextValue
				Log(strData)
				ToastMessageShow("Error: Uncaught error" & CRLF & strData, False)
			End If
		Else
			strError = job.ErrorMessage
			job.Release
			Log(strError)
			Routine.ShowConnectionError(strError)
		End If
	Catch
		job.Release
		LogColor("[AppHome] GetToken: " & LastException.Message, Colors.Red)
		ToastMessageShow("Failed to get access token", False)
	End Try
End Sub

Sub GetProfile
	Dim parser As JSONParser
	Dim job As HttpJob
	Dim List1 As List
	Dim Map1 As Map
	Dim strError As String
	Dim strData As String
	Dim jsn As String
	Try
		LogColor("[AppHome] GetProfile", Colors.Blue)
		ProgressDialogShow("Connecting to server...")
		job.Initialize("", Me)
		job.Download(Starter.strURL & "user/connect")
		Wait For (job) JobDone(job As HttpJob)
		ProgressDialogHide
		If job.Success Then
			strData = job.GetString
			Log(strData)
			job.Release
			parser.Initialize(strData)
			If Routine.isArray(strData) Then
				List1 = parser.NextArray
				Map1 = List1.Get(0)
				If 1 = Map1.Get("Connected") Then
					ProgressDialogShow("Retrieving User Profile...")
					Dim Map2 As Map
					Map2.Initialize
					'Map2.Put("key", Starter.gUserAPIKey)
					LogColor("Token=" & Starter.gUserToken, Colors.Red)
					Map2.Put("token", Starter.gUserToken)
					jsn = Routine.Map2Json(Map2)
					job.Initialize("", Me)
					job.PostString(Starter.strURL & "user/getprofile", jsn)
					Wait For (job) JobDone(job As HttpJob)
					ProgressDialogHide
					If job.Success Then
						strData = job.GetString
						job.Release
						Log(strData)
						parser.Initialize(strData)
						If Routine.isArray(strData) Then
							List1 = parser.NextArray
							Map1 = List1.Get(0)
							If -1 = Map1.Get("result") Then
								If Map1.Get("message") = "Error-No-Result" Or _
									 Map1.Get("message") = "Error-Invalid-Token" Then
									ToastMessageShow("Error: Invalid Access Token", False)
									MsgboxAsync("Please relogin", "Invalid Token")
								Else If Map1.Get("message") = "Error-Not-Authorized" Then
									ToastMessageShow("Error: Invalid Parameters", False)
								Else
									ToastMessageShow("Error: Uncaught error" & CRLF & Map1.Get("message"), False)
								End If
								'Return
							End If
							If Map1.Get("message") = "success" Then								
								Starter.gUserName = Map1.Get("user_name")
								Starter.gUserEmail = Map1.Get("user_email")
								Starter.gUserLocation = Map1.Get("user_location")
							End If
							LoadSlideMenu
						Else
							job.Release
							strData = parser.NextValue
							Log(strData)
							ToastMessageShow("Error: Uncaught error" & CRLF & strData, False)
						End If
					Else
						strError = job.ErrorMessage
						job.Release
						Log(strError)
						Routine.ShowConnectionError(strError)
					End If
				End If
			Else
				job.Release
				strData = parser.NextValue
				Log(strData)
				ToastMessageShow("Error: Uncaught error" & CRLF & strData, False)
			End If
		Else
			strError = job.ErrorMessage
			job.Release
			Log(strError)
			Routine.ShowConnectionError(strError)
		End If
	Catch
		job.Release
		LogColor("[AppHome] GetProfile: " & LastException.Message, Colors.Red)
		ToastMessageShow("Failed to get profile", False)
	End Try
End Sub

Sub GetUserList
	Dim parser As JSONParser
	Dim Job As HttpJob
	Dim List1 As List
	Dim Map1 As Map
	Dim strError As String
	Dim strData As String
	Dim jsn As String
	Dim Rows As Int
	Dim intListUserID As Int
	Dim strListUserName As String
	Dim strListUserStatus As String	
	Try
		If Starter.gUserToken = "" Then
			ToastMessageShow("Error: Invalid Token. Try Login again.", False)
			Return
		End If
		LogColor("[AppHome] GetUserList", Colors.Blue)
		Job.Initialize("", Me)
		ProgressDialogShow("Connecting to server...")
		Job.Download(Starter.strURL & "user/connect")
		Wait For (Job) JobDone(Job As HttpJob)
		ProgressDialogHide
		If Job.Success Then
			strData = Job.GetString
			'Log(strData)
			Job.Release
			parser.Initialize(strData)
			If Routine.isArray(strData) Then
				List1 = parser.NextArray
				Map1 = List1.Get(0)
				If 1 = Map1.Get("Connected") Then
					ProgressDialogShow("Retrieving data...")					
					Dim Map2 As Map
					Map2.Initialize
					'Map2.Put("key", Starter.gUserAPIKey)
					LogColor("Token=" & Starter.gUserToken, Colors.Red)
					Map2.Put("token", Starter.gUserToken)					
					jsn = Routine.Map2Json(Map2)
					Job.Initialize("", Me)
					Job.PostString(Starter.strURL & "user/view/all", jsn)
					Wait For (Job) JobDone(Job As HttpJob)
					ProgressDialogHide
					If Job.Success Then
						strData = Job.GetString
						Log(strData)
						parser.Initialize(strData)
						If Routine.isArray(strData) Then
							List1 = parser.NextArray
							Map1 = List1.Get(0)
							If -1 = Map1.Get("result") Then
								If Map1.Get("message") = "Error-No-Result" Then
									ToastMessageShow("Message: No Results", False)
								Else If Map1.Get("message") = "Error-No-Value" Then
									ToastMessageShow("Error: Invalid Parameters", False)
								Else If Map1.Get("message") = "Error-Invalid-Token" Then
									ToastMessageShow("Error: Invalid Access Token", False)
								Else
									ToastMessageShow("Error: Uncaught error" & CRLF & Map1.Get("message"), False)
								End If
								Return
							End If							
							If List1.Size < 1 Then
								Return
							End If
							Rows = List1.Size
							CLVM.Clear
							For i = 0 To Rows - 1
								Map1 = List1.Get(i)
								intListUserID = Map1.Get("result")
								strListUserName = Map1.Get("user_name")
								strListUserStatus = Map1.Get("online")
								CLVM.Add(CreateList(strListUserName, strListUserStatus, CLVM.AsView.Width), intListUserID)
							Next
						Else
							strData = parser.NextValue
							Log(strData)
							ToastMessageShow("Error: Uncaught error" & CRLF & strData, False)
						End If
					Else
						strError = Job.ErrorMessage
						Job.Release
						Log(strError)
						Routine.ShowConnectionError(strError)
					End If
				End If
			Else
				strData = parser.NextValue
				Log(strData)
				ToastMessageShow("Error: Uncaught error" & CRLF & strData, False)
			End If
		Else
			strError = Job.ErrorMessage
			Job.Release
			Log(strError)
			Routine.ShowConnectionError(strError)
		End If
	Catch
		Job.Release
		LogColor("[AppHome] GetUserList: " & LastException.Message, Colors.Red)
		ToastMessageShow("Failed to retrieve data", False)
	End Try
End Sub

Sub GetUserInfo(id As Int)
	Dim parser As JSONParser
	Dim Job As HttpJob
	Dim List1 As List
	Dim Map1 As Map
	Dim strError As String
	Dim strData As String
	Dim jsn As String
	Try
		If Starter.gUserToken = "" Then
			ToastMessageShow("Error: Invalid Token. Try Login again.", False)
			Return
		End If
		LogColor("[AppHome] GetUserInfo", Colors.Blue)
		Job.Initialize("", Me)
		ProgressDialogShow("Connecting to server...")
		Job.Download(Starter.strURL & "user/connect")
		Wait For (Job) JobDone(Job As HttpJob)
		ProgressDialogHide
		If Job.Success Then
			strData = Job.GetString
			'Log(strData)
			Job.Release
			parser.Initialize(strData)
			If Routine.isArray(strData) Then
				List1 = parser.NextArray
				Map1 = List1.Get(0)
				If 1 = Map1.Get("Connected") Then
					ProgressDialogShow("Retrieving data...")
					Dim Map2 As Map
					Map2.Initialize
					'Map2.Put("key", Starter.gUserAPIKey)
					LogColor("Token=" & Starter.gUserToken, Colors.Red)
					Map2.Put("token", Starter.gUsertoken)
					jsn = Routine.Map2Json(Map2)
					'Log(jsn)
					Job.Initialize("", Me)
					Job.PostString(Starter.strURL & "user/view/" & id, jsn)
					Wait For (Job) JobDone(Job As HttpJob)
					ProgressDialogHide
					If Job.Success Then
						strData = Job.GetString
						Log(strData)
						parser.Initialize(strData)
						If Routine.isArray(strData) Then
							List1 = parser.NextArray
							Map1 = List1.Get(0)
							If -1 = Map1.Get("result") Then
								If Map1.Get("message") = "Error-No-Result" Then
									ToastMessageShow("Message: No Results", False)
								Else If Map1.Get("message") = "Error-No-Value" Then
									ToastMessageShow("Error: Invalid Parameters", False)
								Else
									ToastMessageShow("Error: Uncaught error" & CRLF & Map1.Get("message"), False)
								End If
								Return
							End If
							If List1.Size < 1 Then
								Return
							End If
							Map1 = List1.Get(0)
							lblViewUserName.Text = Map1.Get("user_name")
							txtViewUserLocation.Text = Map1.Get("user_location")
							If Map1.Get("online") = "Y" Then
								lblViewUserStatus.Text = "Online"
								lblViewUserStatus.TextColor = Colors.RGB(50, 205, 50)
							Else
								lblViewUserStatus.Text = "Offline"
								lblViewUserStatus.TextColor = Colors.RGB(105, 105, 105)
							End If
							pnlBlur.Visible = True
							Drawer.GestureEnabled = False
							btnMenu.Enabled = False
						Else
							strData = parser.NextValue
							Log(strData)
							ToastMessageShow("Error: Uncaught error" & CRLF & strData, False)
						End If
					Else
						strError = Job.ErrorMessage
						Job.Release
						Log(strError)
						Routine.ShowConnectionError(strError)
					End If
				End If
			Else
				strData = parser.NextValue
				Log(strData)
				ToastMessageShow("Error: Uncaught error" & CRLF & strData, False)
			End If
		Else
			strError = Job.ErrorMessage
			Job.Release
			Log(strError)
			Routine.ShowConnectionError(strError)
		End If
	Catch
		Job.Release
		LogColor("[AppHome] GetUserInfo: " & LastException.Message, Colors.Red)
		ToastMessageShow("Failed to retrieve data", False)
	End Try
End Sub

Private Sub CreateMenu(MenuIcon As String, MenuText As String, Width As Long) As Panel
	Dim Height As Int = 60dip
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0, 0, Width, Height)
	p.LoadLayout("MenuItem")
	lblMenuIcon.Text = MenuIcon
	lblMenuText.Text = MenuText
	Return p
End Sub

Private Sub CreateList(ListText As String, ListStatus As String, Width As Long) As Panel
	Dim Height As Int = 60dip
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0, 0, Width, Height)
	p.LoadLayout("ListItem")
	lblName.Text = ListText
	If ListStatus = "Y" Then
		pnlStatus.Color = Colors.Green
	Else
		pnlStatus.Color = Colors.Gray
	End If	
	Return p
End Sub

'xui is a global XUI variable.
Sub CreateRoundBitmap (Input As B4XBitmap, Size As Int) As B4XBitmap
	If Input.Width <> Input.Height Then
		'if the image is not square then we crop it to be a square.
		Dim l As Int = Min(Input.Width, Input.Height)
		Input = Input.Crop(Input.Width / 2 - l / 2, Input.Height / 2 - l / 2, l, l)
	End If
	Dim c As B4XCanvas
	Dim xview As B4XView = xui.CreatePanel("")
	xview.SetLayoutAnimated(0, 0, 0, Size, Size)
	c.Initialize(xview)
	Dim path As B4XPath
	path.InitializeOval(c.TargetRect)
	c.ClipPath(path)
	c.DrawBitmap(Input.Resize(Size, Size, False), c.TargetRect)
	c.RemoveClip
	c.DrawCircle(c.TargetRect.CenterX, c.TargetRect.CenterY, c.TargetRect.Width / 2 - 1dip, xui.Color_LightGray, False, 2dip) 'comment this line to remove the border
	c.Invalidate
	Dim res As B4XBitmap = c.CreateBitmap
	c.Release
	Return res
End Sub

Sub CLVM_ItemClick (Index As Int, Value As Object)
	GetUserInfo(Value)
End Sub

Sub lblClose_Click
	pnlBlur.Visible = False
	Drawer.GestureEnabled = True
	btnMenu.Enabled = True
End Sub

Sub NoScroll_Click
	
End Sub